import type { IComponent } from "./api.js";
/**
 * Returns true if given hiccup component describes a comment node. I.e. is of
 * the form `[COMMENT, "foo"...]`.
 *
 * @remarks
 * See thi.ng/hiccup docs for reference:
 *
 * - https://docs.thi.ng/umbrella/hiccup/functions/serialize.html
 *
 * @param tree
 */
export declare const isComment: (tree: any[]) => boolean;
/**
 * Returns true if given value has a {@link IComponent.mount} function.
 *
 * @param x
 */
export declare const isComponent: (x: any) => x is IComponent<any>;
/**
 * Returns true if given value is a DOM element.
 *
 * @param x
 */
export declare const isElement: (x: any) => x is Element;
//# sourceMappingURL=checks.d.ts.map